(
   namespace ("hud");
   
                       ////Normal Boss Health Bar////
  ( "filled_boss_health ( type image; texture textures/ui/boss_bar/filled_boss_health; clip_direction left; color $boss_health_bar_color; bindings [(binding_name #progress_percentage; binding_name_override #clip_ratio)])") ; 
   
   empty_boss_health ( type image; texture textures/ui/boss_bar/empty_boss_health );
   
   filled_boss@filled_boss_health (clip_pixelperfect false; bindings [( binding_name #progress_percentage; binding_name_override #clip_ratio; binding_type ("collection"); binding_collection_name $progress_bar_collection )]); 
      
   boss_health ( type panel; anchor_from ("top_middle"); anchor_to ("top_middle"); offset [0;0]; size [172; 15 ]; controls [( empty_boss_health@empty_boss_health ( layer 1 )); (filled_boss@filled_boss ( layer 2 ))]); 
   
   
                          ////Corruptor Boss Health Bar////
   
   empty_corruptor_health (type image; texture textures/ui/boss_bar/empty_corruptor_health); 
   
   corruptor@filled_corruptor_health (clip_pixelperfect false; bindings [( binding_name #progress_percentage; binding_name_override #clip_ratio; binding_type ("collection"); binding_collection_name $progress_bar_collection )]); 
   
   filled_corruptor_health ( type image; texture textures/ui/boss_bar/filled_corruptor_health; clip_direction left; bindings [( binding_name #progress_percentage; binding_name_override #clip_ratio )]); 
   
   corruptor_health ( type panel; anchor_from ("top_middle"); anchor_to ("top_middle"); offset [0;0]; size [172; 15 ]; controls [(empty_corruptor_health@empty_corruptor_health (layer 1 )); (corruptor@corruptor (layer 2))]; bindings [(binding_name (#bossName = 'The Corruptor'); binding_type ("collection"); binding_collection_name ("boss_bars"); binding_name_override ("#visible"))]); 
   
                       ////Overseer Boss Health Bar////   
   
   empty_overseer_health (type image; texture textures/ui/boss_bar/empty_overseer_health); 
      
   filled_overseer_health (type image; texture textures/ui/boss_bar/filled_overseer_health; clip_direction left; bindings [(binding_name #progress_percentage; binding_name_override #clip_ratio )]); 
   
   overseer@filled_overseer_health (clip_pixelperfect false; bindings [(binding_name #progress_percentage; binding_name_override #clip_ratio; binding_type ("collection"); binding_collection_name $progress_bar_collection)]); 
            
   overseer_health ( type panel; anchor_from ("top_middle"); anchor_to ("top_middle"); offset [0;0]; size [172; 15]; controls [(empty_overseer_health@empty_overseer_health (layer 1)); (overseer@overseer (layer 2))]; bindings [(binding_name (#bossName = 'Overseer'); binding_type ("collection"); binding_collection_name ("boss_bars"); binding_name_override ("#visible") )]); 
         
                       ////Ice Warden Boss Health Bar////         
         
   empty_ice_warden_health (type image; texture textures/ui/boss_bar/empty_ice_warden_health); 

   filled_ice_warden_health ( type image; texture textures/ui/boss_bar/filled_ice_warden_health; clip_direction left; bindings [(binding_name #progress_percentage; binding_name_override #clip_ratio )]); 
         
   ice_warden@filled_ice_warden_health (clip_pixelperfect false; bindings [( binding_name #progress_percentage; binding_name_override #clip_ratio; binding_type ("collection"); binding_collection_name $progress_bar_collection )]);
   
   ice_warden_health ( type panel; anchor_from ("top_middle"); anchor_to ("top_middle"); offset [ 0; 0]; size [172; 15 ]; controls [(empty_ice_warden_health@empty_ice_warden_health (layer 1)); (ice_warden@ice_warden (layer 2))]; bindings [(binding_name (#bossName = 'Ice Warden'); binding_type ("collection"); binding_collection_name ("boss_bars"); binding_name_override ("#visible"))]); 
         
                       ////Prismarine Warden Boss Health Bar////         
         
   empty_prismarine_warden_health (type image; texture textures/ui/boss_bar/empty_prismarine_warden_health );
   
   filled_prismarine_warden_health ( type image; texture textures/ui/boss_bar/filled_prismarine_warden_health; clip_direction left; bindings [(binding_name #progress_percentage; binding_name_override #clip_ratio)]); 
   
   prismarine_warden@filled_prismarine_warden_health (clip_pixelperfect false; bindings [(binding_name #progress_percentage; binding_name_override #clip_ratio; binding_type ("collection"); binding_collection_name $progress_bar_collection)]); 
            
   prismarine_warden_health (type panel; anchor_from ("top_middle"); anchor_to ("top_middle"); offset [0; 0 ]; size [172; 15 ]; controls [(empty_prismarine_warden_health@empty_ice_warden_health ( layer 1)); (prismarine_warden@prismarine_warden ( layer 2))]; bindings [(binding_name (#bossName = 'Prismarine Warden'); binding_type ("collection"); binding_collection_name ("boss_bars"); binding_name_override ("#visible"))]); 
     
                       ////Magma Warden Boss Health Bar////
    
   empty_magma_warden_health (type image; texture textures/ui/boss_bar/empty_magma_warden_health);
   
   filled_magma_warden_health ( type image; texture textures/ui/boss_bar/filled_magma_warden_health; clip_direction left; bindings [(binding_name #progress_percentage; binding_name_override #clip_ratio)]);
         
   magma_warden@filled_magma_warden_health ( clip_pixelperfect false; bindings [( binding_name #progress_percentage; binding_name_override #clip_ratio; binding_type ("collection"); binding_collection_name $progress_bar_collection)]); 
         
   magma_warden_health (type panel; anchor_from ("top_middle"); anchor_to ("top_middle"); offset [0;0]; size [172; 15 ]; controls [(empty_magma_warden_health@empty_magma_warden_health ( layer 1)); (magma_warden@magma_warden (layer 2))]; bindings [(binding_name (#bossName = 'Magma Warden'); binding_type ("collection"); binding_collection_name ("boss_bars"); binding_name_override ("#visible") )]); 
         
         ////Function Panels////
         
   boss_name_panel (
      type panel;
      size [
         100%;
         100%c
      ];
      anchor_from ("top_middle");
      anchor_to ("top_middle");
      controls [
         (
            boss_name (
               type label;
               color $boss_name_text_color;
               text #bossName;
               anchor_from ("top_middle");
               anchor_to ("top_middle");
               shadow true;
               bindings [
                  (
                     binding_name #bossName;
                     binding_type ("collection");
                     binding_collection_name ("boss_bars")
                  )
               ]
            )
         )]); 
   boss_health_panel (
      type panel;
      size [
         188;
         15
      ];
      anchor_from ("top_middle");
      anchor_to ("top_middle");
      $progress_bar_collection ("boss_bars");
      controls [
         (
            boss_name@boss_name_panel (
               layer 3
            )
         );
         (
            boss_health@boss_health (
               offset [
                  0;
                  5
               ];
               layer 1
            )
         );
         (
            overseer_health@overseer_health (
               offset [
                  0;
                  5
               ];
               layer 2
            )
         );
         (
            corruptor_health@corruptor_health (
               offset [
                  0;
                  5
               ];
               layer 2
            )
         );
         (
            ice_warden_health@ice_warden_health (
               offset [
                  0;
                  5
               ];
               layer 2
            )
         );
         (
            prismarine_warden_health@prismarine_warden_health (
               offset [
                  0;
                  5
               ];
               layer 2
            )
         );
         (
            magma_warden_health@magma_warden_health (
               offset [
                  0;
                  5
               ];
               layer 2
            )
         )
      ];
      bindings [
         (
            binding_name ("#bar_visible");
            binding_type ("collection");
            binding_collection_name ("boss_bars");
            binding_name_override ("#visible")
         )]); 
   boss_health_grid (
      type grid;
      grid_dimension_binding #boss_grid_dimension;
      grid_item_template hud.boss_health_panel;
      grid_fill_direction vertical;
      collection_name ("boss_bars");
      anchor_to ("top_middle");
      anchor_from ("top_middle");
      size [
         188;
         40%
      ]
   )
)